{{- $board := .board -}}
{{- $distro := .distro -}}
{{- $suite := .suite -}}
{{- $flavor := .flavor -}}
{{- $repo_prefix := .repo_prefix -}}
{{- $radxa_mirror := .radxa_mirror -}}

{{- $soc := .soc -}}
{{- $soc_family := .soc_family -}}
{{- $image := .image -}}
{{- $efi_end := or .efi_end "332MiB" -}}
{{- $partition_type := .partition_type -}}

{{- $kernel := .kernel -}}
{{- $kernel_dbg := .kernel_dbg -}}
{{- $header := .header -}}
{{- $firmware := .firmware -}}
{{- $overlay := .overlay -}}
{{- $install_vendor_package := or .install_vendor_package "true" -}}

{{- $rbuild_rev := .rbuild_rev -}}
{{- $rbuild_cmd := .rbuild_cmd -}}
{{- $kernel_profile := .kernel_profile -}}

{{- $architecture := .architecture -}}

architecture: {{ $architecture }}

actions:
  - action: image-partition
    description: Set up on-disk layout
    imagename: {{ $image }}
    imagesize: 6GiB
    partitiontype: {{ $partition_type }}
    mountpoints:
      - mountpoint: /
        partition: rootfs
      - mountpoint: /config
        partition: config
        options: [ x-systemd.automount ]
      - mountpoint: /boot/efi
        partition: boot
        options: [ x-systemd.automount ]
    partitions:
      - name: config
        fs: vfat
        start: 16MiB
        end: 32MiB
      - name: boot
        fs: vfat
        start: 32MiB
        end: {{ $efi_end }}
        flags: [ boot, esp ]
      - name: rootfs
        fs: ext4
        start: {{ $efi_end }}
        end: 100%
        flags: [ boot ]

  - action: unpack
    description: Unpack rootfs
    file: .rootfs/{{ $distro }}_{{ $suite }}{{ $repo_prefix }}_{{ $flavor }}.tar

  - action: filesystem-deploy
    description: Deploying filesystem onto image
    setup-fstab: true
    # u-boot-menu will add root= in append for us
    setup-kernel-cmdline: false

  - action: apt
    description: Install task-{{ $board }} package
    packages:
      - task-{{ $board }}

{{ if and (ne $install_vendor_package "false") (eq $distro "debian") }}

  - action: recipe
    description: Add {{ $soc_family }}-{{ $suite }} Repo
    recipe: scripts/add_radxa_repo.yaml
    variables:
      origin: radxa-{{ $soc_family }}
      suite: {{ $soc_family }}-{{ $suite }}{{ $repo_prefix }}
      repo: {{ $suite }}{{ $repo_prefix }}
      radxa_mirror: {{ $radxa_mirror }}

  {{ if and (eq $install_vendor_package "true") (ne $flavor "cli") }}

  - action: run
    description: Install task-{{ $board }} with vendor packages
    chroot: true
    command: |
      dpkg --remove --force-depends task-{{ $board }}
      apt-get update
      apt-get install -o Dpkg::Options::="--force-confnew" -y --install-recommends task-{{ $board }}

  {{ else if ne $install_vendor_package "true" }}

  - action: apt
    description: Install {{ $install_vendor_package }} package
    packages:
      - {{ $install_vendor_package }}

  {{ end }}

{{ end }}

  - action: run
    description: Upgrade stale rootfs
    chroot: true
    command: |
      set -e
      apt-get update
      apt-get full-upgrade -y --allow-downgrades
      apt-get full-upgrade -y --allow-downgrades
      apt-get autoremove -y --purge

{{ if eq $kernel_profile "" }}

  {{ if eq $firmware "" }}

  - action: apt
    description: Install Radxa firmware
    packages:
      - u-boot-{{ $board }}

  {{ else }}

  - action: recipe
    description: Install custom firmware
    recipe: scripts/hack_install_deb.yaml
    variables:
      name: {{ $firmware }}

  {{ end }}
  
  - action: run
    description: Apply to disk
    chroot: true
    command: |
      set -e
      ROOTPART="$(mount | grep " on / " | cut -d ' ' -f 1)"
      ROOTDEV="$(lsblk -no pkname $ROOTPART)"
      TARGET="/dev/$ROOTDEV"
      echo "Writting to $TARGET"
      /usr/lib/u-boot/{{ $board }}/setup.sh update_bootloader "$TARGET" {{ $soc_family }}

{{ end }}

{{ if eq $header "" }}

  - action: apt
    description: Install Radxa kernel header
    packages:
  {{ if eq $kernel_profile "" }}
      - linux-headers-{{ $board }}
  {{ else }}
      - linux-headers-{{ $kernel_profile }}
  {{ end }}

{{ else }}

  - action: recipe
    description: Install custom kernel header
    recipe: scripts/hack_install_deb.yaml
    variables:
      name: {{ $header }}

{{ end }}

{{ if eq $kernel "" }}

  - action: apt
    description: Install Radxa kernel
    packages:
  {{ if eq $kernel_profile "" }}
      - linux-image-{{ $board }}
  {{ else }}
      - linux-image-{{ $kernel_profile }}
  {{ end }}

{{ else }}

  - action: recipe
    description: Install custom kernel
    recipe: scripts/hack_install_deb.yaml
    variables:
      name: {{ $kernel }}

{{ end }}

{{ if ne $kernel_dbg "" }}

  - action: recipe
    description: Install custom debug kernel
    recipe: scripts/hack_install_deb.yaml
    variables:
      name: {{ $kernel_dbg }}

{{ end }}

{{ if $overlay }}

  - action: recipe
    description: Enable overlay {{ $overlay }}
    recipe: scripts/enable_overlay.yaml
    variables:
      overlay: {{ $overlay }}

{{ end }}

  - action: run
    description: Product specific setup
    chroot: true
    command: |
      set -e
      rsetup update_hostname citadel
      echo "RBUILD_BUILD_DATE='$(date -R)'" > /etc/radxa_image_fingerprint
      echo "RBUILD_REVISION='{{ $rbuild_rev }}'" >> /etc/radxa_image_fingerprint
      echo "RBUILD_COMMAND='{{ $rbuild_cmd }}'" >> /etc/radxa_image_fingerprint
      if ! pkg_info="$(dpkg-query -f '${binary:Package} ${Version}\n' -W | grep -v -e {{ $board }} | grep linux-image)"
      then
        pkg_info="$(dpkg-query -f '${binary:Package} ${Version}\n' -W | grep linux-image-{{ $board }})"
      fi
      echo "RBUILD_KERNEL='$(echo $pkg_info | cut -d ' ' -f 1)'" >> /etc/radxa_image_fingerprint
      echo "RBUILD_KERNEL_VERSION='$(echo $pkg_info | cut -d ' ' -f 2)'" >> /etc/radxa_image_fingerprint
      if pkg_info="$(dpkg-query -f '${binary:Package} ${Version}\n' -W | grep -v -e {{ $board }} -e u-boot-menu -e u-boot-tools | grep u-boot)"
      then
        echo "RBUILD_UBOOT='$(echo $pkg_info | cut -d ' ' -f 1)'" >> /etc/radxa_image_fingerprint
        echo "RBUILD_UBOOT_VERSION='$(echo $pkg_info | cut -d ' ' -f 2)'" >> /etc/radxa_image_fingerprint
      else
        echo "RBUILD_UBOOT='EFI-System'" >> /etc/radxa_image_fingerprint
        echo "RBUILD_UBOOT_VERSION='1'" >> /etc/radxa_image_fingerprint
      fi

  - action: recipe
    description: Clean up rootfs
    recipe: scripts/clean.yaml

{{ if eq $suite "bookworm" }}
  - action: run
    description: Workaround cloud-initramfs-growroot bug
    chroot: true
    command: |
      echo "copy_exec /usr/bin/grep /bin" >> /usr/share/initramfs-tools/hooks/growroot
      echo "copy_exec /usr/bin/sed /bin" >> /usr/share/initramfs-tools/hooks/growroot
      echo "copy_exec /usr/bin/rm /bin" >> /usr/share/initramfs-tools/hooks/growroot
      echo "copy_exec /usr/bin/awk /bin" >> /usr/share/initramfs-tools/hooks/growroot
{{ end }}

  - action: run
    description: Rebuild initramfs to not waiting for (now missing) suspend/resume device
    chroot: true
    command: |
      set -e
      update-initramfs -u
